#' @title analyse_damage
#'
#' @description
#' TO BE PRECISED
#'
#' @param Farm TO BE PRECISED.
#' @param s TO BE PRECISED, default to
#' `Farm[["Parameters"]][["signature"]][["save"]]`.
#' @param g TO BE PRECISED, default to
#' `Farm[["Parameters"]][["signature"]][["graph"]]`.
#'
#' @return matrix, TO BE PRECISED.
#'
#' @export
#'
#' @encoding UTF-8

analyse_damage = function(
    Farm,
    s = Farm[["Parameters"]][["signature"]][["save"]], 
    g = Farm[["Parameters"]][["signature"]][["graph"]]
) {
    e_gross = list_to_matrix(
        lapply(Farm[-1], 
        function(x){x[["Damage"]][["Financial"]]["gross", , drop = FALSE]}))
    e_net = list_to_matrix(
        lapply(Farm[-1], 
        function(x){x[["Damage"]][["Financial"]]["net", , drop = FALSE]}))
    e_insurance = list_to_matrix(
        lapply(Farm[-1], 
        function(x){x[["Damage"]][["Financial"]]["insurance", , drop = FALSE]}))
    s_gross = rbind(e_gross[1, , drop = FALSE],
        list_to_matrix(lapply(Farm[-c(1,2)], 
        function(x){x[["Damage"]][["Solidarity"]]["gross", , drop = FALSE]})))
    s_net = rbind(e_net[1, , drop = FALSE],
        list_to_matrix(lapply(Farm[-c(1,2)], 
        function(x){x[["Damage"]][["Solidarity"]]["net", , drop = FALSE]})))
    s_insurance = rbind(e_insurance[1, , drop = FALSE],
        list_to_matrix(lapply(Farm[-c(1,2)], 
        function(x){x[["Damage"]][["Solidarity"]]["insurance", , drop = FALSE]})))
    economic = list_to_matrix(
        lapply(Farm[-1], 
        function(x){x[["Damage"]][["Economic"]]}))
    if (s) {
        file_output = file.path(
                Farm[["Parameters"]][["signature"]][["path"]],
                Farm[["Parameters"]][["signature"]][["output"]]
        )
        profile = Farm[["Parameters"]][["signature"]][["profile"]]
        save_output(
            round(e_gross, 0),
            profile,
            "Damage-Financial-Gross",
            file_output
        )
        save_output(
            round(e_net, 0),
            profile,
            "Damage-Financial-Net",
            file_output
        )
        save_output(
            round(e_insurance, 0),
            profile, 
            "Damage-Financial-Insured", 
            file_output
        )
        save_output(
            round(s_gross, 0),
            profile, 
            "Damage-Solidarity-Gross", 
            file_output
        )
        save_output(
            round(s_net, 0),
            profile, 
            "Damage-Solidarity-Net", 
            file_output
        )
        save_output(
            round(s_insurance, 0),
            profile, 
            "Damage-Solidarity-Insured", 
            file_output
        )
        save_output(
            round(economic, 0),
            profile, 
            "Damage-Economic", 
            file_output
        )
    }

    r = list(
        external_gross = e_gross, 
        external_net = e_net,
        external_insurance = e_insurance, 
        solidarity_gross = e_gross, 
        solidarity_net = e_net,
        solidarity_insurance = e_insurance, 
        economic = economic)

    invisible(r)
}