#' @title calc_duration
#'
#' @description
#' TO BE PRECISED
#'
#' @param begin numeric vector.
#' @param end numeric vector, default to NULL.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#' 
#' @return numeric vector, taking into case begin > end and inverse.
#'
#' @export
#'
#' @encoding UTF-8

calc_duration = function(
    begin,
    end = NULL,
    cal_length = getOption("ava")[["cal_length"]]
) {
    if (is.null(end)) {
        end = begin[, 2]
        begin = begin[, 1]
    }
    if (any(begin > cal_length) | any(end > cal_length) | any(begin < 1) | any(end < 1))
        stop("begin or end is not well formatted.")
    result = end - begin + 1
    result[begin > end] = cal_length - begin[begin > end] + end[begin > end] + 1
    return(result)
}