#' @title check
#'
#' @description
#' TO BE PRECISED.
#'
#' @param parameter TO BE PRECISED.
#' @param correct logical, should parameter be corrected. Default to `getOption("ava")[["correct"]]`.
#'
#' @return NULL. Only warnings are useful.
#'
#' @export
#'
#' @encoding UTF-8

check = function(parameter, correct = getOption("ava")[["correct"]]) {
    content = scan(parameter, what = "", sep = "\n", quiet = TRUE)
    
    # blank character
    t1 = grep(" ", content)
    if (length(t1) > 0)
    {
        msg = paste(t1, collapse= " ; ")
        msg = paste(
            "Found ",
            length(t1),
            " line(s) whith some blanks (", 
            msg,
            ") in ",
            parameter,
            sep = ""
        )
        warning(msg)
    }
    content = gsub(" ", "", content)
    
    # Empty lines ?
    t2 = grep("^;+$", content)
    if (length(t2) > 0)
    {
        msg = paste(t2, collapse= " ; ")
        msg = paste(
            "Found ",
            length(t2),
            " empty line(s) (",
            msg,
            ") in ", 
            parameter,
            sep = ""
        )
        warning(msg)
        content = content[-t2]
    }
    
    if (correct && (length(t1) + length(t2)) > 0)
    {
        write(content, parameter, sep = "\n")
        warning(paste(parameter, "has been corrected"))
    }
    return(NULL)
}