#' @title coherency
#'
#' @description
#' TO BE PRECISED.
#'
#' @param A matrix, or something that can be converted is a matrix with
#' as.matrix.
#' @param B matrix, or something that can be converted is a matrix with
#' as.matrix. May be NULL.
#' @param rows integer, TO BE PRECISED. Default to NULL.
#' @param cols integer, TO BE PRECISED. Default to NULL.
#' @param fill nuemeric, TO BE PRECISED. Default to O.
#'
#' @return matrix, TO BE PRECISED.
#' 
#' @examples
#' A = matrix(1, 3, 3, dim = list(c("a", "b", "c"), 1:3))
#' B = matrix(c(0,2), 4, 4, dim = list(4:7, 2:5))
#' coherency(A, B, rows = 0, cols = 0)
#'
#' @export
#'
#' @encoding UTF-8

coherency = function(A, B = NULL, rows = NULL, cols = NULL, fill = 0) {
    r = A = as.matrix(A)
    
    if (!is.null(B))
    {
        B = as.matrix(B)
        row_names = unique(c(rownames(A), rownames(B)))
        col_names = unique(c(colnames(A), colnames(B)))
        r = matrix(
            fill,
            nrow = length(row_names),
            ncol = length(col_names),
            dimnames = list(row_names, col_names)
        )
        r[rownames(A), colnames(A)] = A
        r[rownames(B), colnames(B)] = B
    } 
    
    if (!is.null(rows))
    {
        if (length(rows) == 1 && rows == 0) {
            rows = which(apply(r, 1, function(x){!all(x == 0)}))
        }
    } else {
        rows = rownames(r)
    }
    
    if (!is.null(cols))
    {
        if (length(cols) == 1 && cols == 0) {
            cols = which(apply(r, 2, function(x){!all(x == 0)}))
        }
    } else {
        cols = colnames(r)
    }
    
    r = r[rows, cols, drop = FALSE]

    return(r)
}
