#' @title distribute_resource
#'
#' @description
#' TO BE PRECISED.
#'
#' @param Task TO BE PRECISED, Matrix of tasks to be done.
#' @param A TO BE PRECISED, Calendar of available units of resources.
#' @param L TO BE PRECISED, Matrix of links giving what ressources are needed.
#' for each task.
#' @param p TO BE PRECISED, profile,  default to "internal".
#' @param selection TO BE PRECISED, default to NULL.
#'
#' @return TO BE PRECISED, Return numerical vector of length `getOption("ava")[["cal_length"]]`
#'
#' @export
#'
#' @encoding UTF-8

distribute_resource = function(Task, A, L, p = "internal", selection = NULL) {
    r = list()
    N = need_resource(Task, L)
    
    A = make_coherent(fit_process(A), rownames(N))
    
    r[["internal"]] = pmin(N, A[["internal"]])
    if (p == "internal")
    {
        N = N - r[["internal"]]
        r[["external"]] = pmin(N, A[["external"]])
    } else 
    {
        r[["external"]] = pmax(N - A[["internal"]], 0)
    }
        
    if (is.null(selection)) return(r)
    
    Task = Task[selection, ]
    if (length(selection) == 1)
    {
        task = t(Task)
        rownames(Task) = selection
    }
    r = sub_distribute_resource(r, Task, L)

    return(r)
}