#' @title estimate_dam_economic
#'
#' @description
#' DESCRIPTION NEEDED
#'
#' @param NP TO BE PRECISED.
#' @param NE TO BE PRECISED.
#' @param P TO BE PRECISED, default to NULL.
#' @param E TO BE PRECISED, default to NULL.
#' @param FU TO BE PRECISED, default to NULL.
#' @param D TO BE PRECISED, default to NULL.
#' @param benchmark TO BE PRECISED, default to FALSE.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8


estimate_dam_economic = function(
    NP,
    NE,
    P = NULL,
    E = NULL,
    FU = NULL,
    D = NULL,
    benchmark = FALSE
) {
    
    DAMAGE = c("building", "furniture", "plantmaterial", "soil", "product", 
        "tool", "input", "labour")
    EXPENSE = c("tool", "input")
    CAPITAL = c("building", "soil")
    
    r = matrix(NA, nrow = 1, ncol = 1 + length(DAMAGE),
        dimnames = list("value", c("total", DAMAGE)))

    if (benchmark)
    {
        r[, EXPENSE] = NE[["plot"]][EXPENSE]
        r[, "product"] = sum(NP[, "product"])
        r[is.na(r)] = 0
        r[, "total"] = r[, "product"] - sum(r[, EXPENSE])
    } else {
        if (any(c(is.null(P), is.null(E), is.null(FU))))
            stop("Missing arguments.")

        if (!is.null(D)) r[, colnames(D)] = D
        r[, "furniture"] = sum(FU[, "damage"])
        r[, CAPITAL] = sapply(E[CAPITAL], sum)
        r[, EXPENSE] = E[["plot"]][EXPENSE] - NE[["plot"]][EXPENSE]
        r[, "product"] = sum(NP[, "product"]) - sum(P[, "product"])
        r[, "total"] = sum(r[, DAMAGE], na.rm = TRUE)
    }
    
    return(r)
}