#' @title estimate_dam_financial
#'
#' @description
#' DESCRIPTION NEEDED
#'
#' @param NP TO BE PRECISED.
#' @param NE TO BE PRECISED.
#' @param P TO BE PRECISED, default to NULL.
#' @param E TO BE PRECISED, default to NULL.
#' @param FU TO BE PRECISED, default to NULL.
#' @param culture TO BE PRECISED, default to NULL.
#' @param D TO BE PRECISED, default to NULL.
#' @param benchmark TO BE PRECISED, default to FALSE.
#' @param expense_cat numeric, TO BE PRECISED. Default to
#' `getOption("ava")[["expense_cat"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

estimate_dam_financial = function(
    NP,
    NE, 
    P = NULL,
    E = NULL,
    FU = NULL,
    culture = NULL,
    D = NULL,
    benchmark = FALSE,
    expense_cat = getOption("ava")[["expense_cat"]]
) {
    #print(str(FU))
    damage = c("building", "furniture", "plantmaterial", "soil", "income")
    detail = c("product", expense_cat)
    product = c("income", "product")

    r = matrix(0, nrow = 3, ncol = 1 + length(damage) + length(detail),
        dimnames = list(c("gross", "insurance", "net"), c("total", damage, 
        detail)))

    if (benchmark)
    {
        r["gross", expense_cat] = NE[["plot"]][expense_cat]
        r["gross", "product"] = sum(NP[, "product"])
        r[, "income"] = r[, "product"] - apply(r[, expense_cat, drop = FALSE], 1, sum)
    } else {
        if (any(c(is.null(P), is.null(E), is.null(FU), is.null(culture))))
            stop("Missing arguments.")

        if (!is.null(D)) r[, colnames(D)] = D
            
        r["gross", "furniture"] = sum(FU[, "damage"])
        r["gross", c("building", "soil")] = 
            sapply(E[c("building", "soil")], sum)
        r["gross", expense_cat] = E[["plot"]][expense_cat] - NE[["plot"]][expense_cat]
        r["gross", "product"] = sum(NP[, "product"]) - sum(P[, "product"])
        
        r["insurance", c("building", "furniture", "plantmaterial", "soil", 
            "product")] = insurance(r["gross", damage], P[, "product"], 
            NP[, "product"], culture)
        r[, "income"] = apply(r[, detail, drop = FALSE], 1, sum)
    }
    
    r[, "total"] = apply(r[, damage, drop = FALSE], 1, sum)

    r["net", ] = r["gross", ] - r["insurance", ]

    return(r)
}