#' @title estimate_expense
#'
#' @description
#' TO BE PRECISED.
#'
#' @param Calendar TO BE PRECISED.
#' @param Price TO BE PRECISED.
#' @param option character, TO BE PRECISED. Default value to "summary".
#' @param expense_cat numeric, TO BE PRECISED. Default to
#' `getOption("ava")[["expense_cat"]]`.
#' @param process character, farm profiles to be processed. Default to
#' `getOption("ava")[["process"]]`.
#' 
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

estimate_expense = function(
    Calendar,
    Price,
    option = "summary",
    expense_cat = getOption("ava")[["expense_cat"]],
    process = getOption("ava")[["process"]]
)
    # option = c("summary", "calendar")
{
    if (!(option %in% c("summary", "calendar"))) stop("Bad option")
    
    r = list()
    for (item in expense_cat)
    {
        r[[item]] = list()
        for (i in process)
        {
            subitem = rownames(Calendar[[item]][[i]])
            r[[item]][[i]] = Calendar[[item]][[i]] * 
                Price[[item]][subitem, i]
        }
    }
    if (option == "calendar") return(r)
    
    sum_by_source = function(x)
    {
       sum(rowSums(x[["internal"]]), na.rm = TRUE) + sum(rowSums(x[["external"]]), na.rm = TRUE)
    }
    r = sapply(r, sum_by_source)
    return(r)
}