#' @title estimate_product
#' 
#' @description
#' TO BE PRECISED.
#'
#' @param Calendar TO BE PRECISED.
#' @param Task TO BE PRECISED.
#' @param Plot TO BE PRECISED.
#' @param Loss TO BE PRECISED, default to NULL.
#' @param option character, TO BE PRECISED, default to "all".
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

estimate_product = function(Calendar, Task, Plot, Loss = NULL, option = "all") {
    calc_loss = function(x) {1 - prod(1 -x)}
    tag_name = function(x, name) {
        r = character(length(x))
        for (n in name) r[grep(n, x)] = n
        return(r)
    }
    
    if (is.null(Loss)) Loss = matrix(
            0,
            nrow = nrow(Plot),
            ncol = 2,
            dimnames = list(rownames(Plot), c("plant_material", "culture"))
        )
    
    Loss = cbind("total" = 0, Loss, "task" = 0) 
    r = cbind("product" = 0, Plot, Loss)
    tag = tag_name(rownames(Calendar), rownames(Plot))
    
    select = tag %in% rownames(Plot)
    Calendar = Calendar[select, ]
    tag = tag[select]
    Task = Task[select, ]
    
    rate = rowSums(Calendar) / (Task[, "labour"] * r[tag, "area"])
    rate[is.nan(rate)] = 1
    loss = (1 - rate) * Task[, "loss"]
    r[, "task"] = stats::aggregate(loss, by = list(tag), calc_loss)[["x"]]
    r[, "total"] = 
        apply(r[, c("plant_material", "culture", "task")], 1, calc_loss)
    r[, "yield"] = r[, "yield"] * (1 - r[, "total"])
    r[, "product"] = 
        apply(r[, c("yield", "area", "price")], 1, prod)

    if (option == "product") r = r[, "product"]

    return(r)
}