#' @title format_hazard
#'
#' @description
#' TO BE PRECISED.
#'
#' @param Hazard TO BE PRECISED.
#' @param ordered_parameter TO BE PRECISED. Default value to `getOption("ava")[["hazard_dim"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

format_hazard = function(Hazard, ordered_parameter = getOption("ava")[["hazard_dim"]])
    # - Hazard : data.frame or matrix with named columns, including at least 
    #   elevation of each asset (row)
    # - Value : matrix with names columns exactly equal to orderd_parameter
{
    if (is.vector(Hazard)) Hazard = t(Hazard) else Hazard = as.matrix(Hazard)
    parameter = colnames(Hazard)
    
    r = matrix(NA, nrow = nrow(Hazard), ncol = length(ordered_parameter),
        dimnames = list(
            "location" = rownames(Hazard), 
            "parameter" = ordered_parameter))
    present = ordered_parameter[ordered_parameter %in% parameter]
    r[, present] = Hazard[, present]
    if ("begin" %in% parameter)
        r[, "week"] = Hazard[, "begin"]
    if (all(c("begin", "end") %in% parameter))
        r[, "duration"] = calc_duration(Hazard[, "begin"], Hazard[, "end"])
    sel = r[, "height"] == 0
    r[sel, c("week", "duration")] = NA
    return(r)
}