#' @title graph_usability
#'
#' @description
#' TO BE PRECISED.
#'
#' @param Furniture TO BE PRECISED.
#' @param s logical, TO BE PRECISED. Default value to FALSE.
#' @param path character, TO BE PRECISED. Default value to NULL.
#' @param name character, TO BE PRECISED. Default value to NULL.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#' @param path_output character, output directory. Default to
#' `getOption("ava")[["path_output"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

graph_usability = function(
    Furniture,
    s = FALSE,
    path = NULL,
    name = NULL,
    cal_length = getOption("ava")[["cal_length"]],
    path_output = getOption("ava")[["path_output"]]
) {
    Furniture = cbind(Furniture[,  c("week", "duration")], 
        "week.2" = fit_date(Furniture[, "week"] + Furniture[, "duration"]),
        "unavailability" = Furniture[, c("unavailability")])
    
    l = nrow(Furniture)

    state_bg = matrix("white", nrow = l, ncol = cal_length)
    state_bg[!usability(Furniture[, c(1, 2)])] = "black"
    state_bg[!usability(Furniture[, c(3, 4)])] = "gray"
    
    file_pdf = file.path(path_output, path, paste("State-", name, ".pdf", sep = ""))
    if (s) grDevices::pdf(file_pdf, width = 14 , height = .5*l)
    
    y_top = 0.3 + .05 * (l+1)
    x = seq(cal_length)
    y = rep(y_top, cal_length)

    graphics::par(mar = c(5, 5, 4, 2), pch = 22 , cex = 2 , lwd = 1.5 , cex.axis = .5 , cex.lab = .5, 
        col = "gray" , bg = "white" , mgp = c(3, 0.5, 0))
    
    graphics::plot.new()
    graphics::plot.window(xlim = c(0, cal_length) , ylim = c(0, y_top))
    graphics::title(main = "Chronologie des \u00E9tats des composants" , xlab = "Semaines")

    for (i in seq(l))
    {
        graphics::points(x , y -.3 - 0.05 * i , bg = state_bg[i, ])
    }
    
    graphics::axis(1, at = x, labels = gen_label(), cex = 1, lwd = 1 , line = 1)
    graphics::axis(2, at = y_top -.3 - .05 *seq(l) , labels = rownames(Furniture), 
        las = 1 , hadj = 1 , cex = 1, lwd = 0 , line = 0)

    graphics::legend(x = "topright" , horiz = TRUE, 
        legend = c("Normal", "Endommag\u00E9", "En r\u00E9paration"), 
        pt.bg = c("white","black","gray"), 
        pch = 22, lty = 0, cex = .5, pt.cex = 1, text.col = "black")

    if (s) grDevices::dev.off() 
}
