#' @title graph_usage
#'
#' @description
#' TO BE PRECISED.
#'
#' @param Before TO BE PRECISED.
#' @param After TO BE PRECISED.
#' @param type character. TO BE PRECISED. Default value to "general".
#' @param s logical, TO BE PRECISED. Default value to FALSE.
#' @param path character, TO BE PRECISED. Default value to NULL.
#' @param name character, TO BE PRECISED. Default value to NULL.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#' @param path_output character, output directory. Default to
#' `getOption("ava")[["path_output"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

graph_usage = function(
    Before,
    After,
    type = "general",
    s = FALSE,
    path = NULL,
    name = NULL,
    cal_length = getOption("ava")[["cal_length"]],
    path_output = getOption("ava")[["path_output"]]
) {
    ramp = grDevices::colorRamp(c("white", "red"))
    if (!(type %in% c("general", "mono"))) stop("Unimplemented type chosen.")

    if (is.vector(Before)) Before = t(Before)
    if (is.vector(After)) After = t(After)
    if (nrow(Before) < nrow(After)) After = After[rownames(Before), ]
    if (ncol(Before) != ncol(After)) stop("Not the same number of column in Before and After.")

    if (type == "mono")
    {
        ylim = c(0, max(as.matrix(Before), as.matrix(After)))
        if (nrow(Before) > 1 & !s) graphics::par(ask = TRUE)
        
        for (i in seq(nrow(Before)))
        {
            if (s)
            { 
                file_pdf = file.path(path_output, path, paste("Usage-", name, "-", rownames(Before)[i], ".pdf", sep = ""))
                grDevices::pdf(file_pdf, width = 14 , height = 6)
            }
            
            graphics::barplot(Before[i, ], col = "gray", ylim = ylim)
            graphics::barplot(After[i, ], col = "red", add = TRUE)
            graphics::barplot(pmin(Before[i, ], After[i, ]), col = "white", add = TRUE)

            graphics::title(main = rownames(Before)[i] , xlab = "Semaines")
            if (s) grDevices::dev.off()
        }
    }

    if (type == "general")
    {
        l = nrow(Before)
        y_offset  = .2
        y_top = y_offset + .05 * (l+1)
        x = seq(cal_length)
        y = rep(y_top, cal_length)
        
        if (s)
        {
            file_pdf = file.path(path_output, path, paste("Usage-", name, "-general.pdf", sep = ""))
            grDevices::pdf(file_pdf, width = 14 , height = 3 + .255 * l) #1.8 + .30 * l
        }

        old.par = graphics::par(pch = 22 , cex = 2 , lwd = 1.5 , cex.axis = .5 , 
            cex.lab = .5, col = "gray" , bg = "white" ,
            omi = c(0, 0, 0, 0), mai = c(1, 2, .8, .2), mgp = c(1, 0.4, 0))
        
        graphics::plot.new()
        graphics::plot.window(xlim = c(0, cal_length) , ylim = c(0, y_top))
        graphics::title(main = "Chronologie des \u00E9tats des composants" , xlab = "Semaines")

        for (i in seq(l))
        {
            bg = rep("white", cal_length)
            bg[Before[i, ] == After[i, ] & Before[i, ] > 0] = "black"
            sel = Before[i, ] > After[i, ]
            #bg[sel] = gray(.5 *(After[i, sel] / Before[i, sel]) +.5)
            bg[sel] = "gray"
            sel = Before[i, ] < After[i, ] 
            #bg[sel] = rgb(ramp(Before[i, sel] / After[i, sel]), max = 255)
            bg[sel] = "red"
            
            graphics::points(x , y - y_offset - 0.05 * i , bg = bg)
        }

        graphics::axis(1, at = x, labels = gen_label(), cex = 1, lwd = 1 , line = 0)
        graphics::axis(2, at = y_top - y_offset - .05 * seq(l) , labels = rownames(Before), 
            las = 1 , hadj = 1 , cex = 1, lwd = 0 , line = 0)

        graphics::legend(x = "topright", horiz = TRUE,
            legend = c("Out of use", "Normal", "Under", "Over"), 
            pt.bg = c("white", "black", "gray", "red"), text.col = "black",
            pch = 22, lty = 0, lwd = c(1,2,1), cex = .5, pt.cex = 1,
            inset = c(0.05, 0.1))

        graphics::par(old.par)
        if (s) grDevices::dev.off()
    }
}
