#' @title hazard_furniture
#'
#' @description
#' TO BE PRECISED.
#'
#' @param F TO BE PRECISED.
#' @param S TO BE PRECISED.
#' @param DF TO BE PRECISED.
#' @param DT TO BE PRECISED.
#' @param I TO BE PRECISED.
#' @param hazard_dim character, hazard dimensions. Default to 
#' `getOption("ava")[["generic"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

hazard_furniture = function(
    F,
    S,
    DF,
    DT,
    I,
    hazard_dim = getOption("ava")[["hazard_dim"]]
) {
    hazard = S[as.character(F[, "location"]), ]
    tool = rownames(F)[F[, "class"] == "tool"]
    input = rownames(F)[F[, "class"] == "input"]
   
    r = cbind(F, localize_hazard(F[, "elevation"], hazard))
    r = cbind(r, damaging(DF, r[c(hazard_dim, "type")]))

    r = cbind(r, "damage" = r[, "damaging"] * r[, "price"] * r[, "quantity"])
    destroyed = rownames(r[tool, ])[r[tool, "damaging"] == 1]
    if (length(destroyed) > 0)
    {
        r[destroyed, "damage"] = r[destroyed, "damage"] * 
            DT[match(r[destroyed, "age"], DT[["age"]]), "discount"]
    }
    r[input, "damage"] = r[input, "damage"] * select_date(I[input, ], r[input, "week"])
    sel = is.na(r[, "damage"])
    r[sel, "damage"] = 0
    
    return(r)
}