#' @title init_calendar
#'
#' @description
#' Initialise calendar.
#'
#' @param n character, row names of calendar
#' @param v data values to be passed in calendar. See `matrix()` for format
#' Default to 0.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#'
#' @return matrix of `n` rows, `cal_length` (weeks) columns and with `v` values
#'
#' @export
#'
#' @encoding UTF-8

init_calendar = function(
    n,
    v = 0,
    cal_length = getOption("ava")[["cal_length"]]
) {
    matrix(
        v,
        nrow = length(n),
        ncol = cal_length, 
        dimnames = list("element" = n, "week" = seq(cal_length))
    )
}