#' @title insurance
#'
#' @description
#' TO BE PRECISED.
#'
#' @param damage TO BE PRECISED.
#' @param p_flood TO BE PRECISED.
#' @param p_normal TO BE PRECISED.
#' @param culture TO BE PRECISED.
#' @param s_normal TO BE PRECISED. Default to NULL.
#' @param s_flood TO BE PRECISED. Default to NULL.
#' @param catnat list, insurance minimum threshold and rate. Default to
#' `getOption("ava")[["catnat"]]`.
#' @param fngca list, insurance minimum threshold and rate for the French 
#' National Agricultural Risk Management Fund. Default to 
#' `getOption("ava")[["fngca"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

insurance = function(
    damage,
    p_flood,
    p_normal,
    culture,
    s_normal = NULL,
    s_flood = NULL,
    catnat = getOption("ava")[["catnat"]],
    fngca = getOption("ava")[["fngca"]]
)
{
    fit_subsidy = function(culture)
    {
        r = rep(0, length(culture))
        names(r) = culture
        return(r)
    }
    
    if (is.null(s_normal)) s_normal = fit_subsidy(culture)
    if (is.null(s_flood)) s_flood = fit_subsidy(culture)
    
    r = matrix(NA, nrow = 1, ncol = 5,
        dimnames = list("insurance", 
        c("building", "furniture", "plantmaterial", "soil", "product")))
    
    good = c("furniture", "building")
    indemnity = max(0, sum(damage[good]) - max(catnat[["min"]], sum(damage[good]) * catnat[["rate"]]))
    r[, good] = indemnity * damage[good] / sum(damage[good])
    
    land = c("soil", "plantmaterial")
    r[, land] = damage[land] * fngca[["land"]]
    
    indemnity = 0
    if ((1 - (sum(p_flood) + sum(s_normal)) / (sum(p_normal) + sum(s_normal))) > 
        fngca[["global"]])
    {
        for (i in seq(length(culture)))
        {
            normal = p_normal[i] + s_normal[i]
            flood = p_flood[i] + s_flood[i]
            if ((1 - flood / normal) > fngca[[culture[i]]][["threshold"]])
                indemnity = indemnity +
                    (p_normal[i] - p_flood[i]) * fngca[[culture[i]]][["rate"]] 
        }
    }
    r[, "product"] = indemnity

    r[is.nan(r)] = 0

    return(r)
}