#' @title interpolate
#'
#' @description
#' TO BE PRECISED.
#' interpolate is adapted frome package e1071
#' Warnings : when cycling is used, x should be well formatted to fit bound.
#'
#' @param x array, values to be interpolated.
#' @param a numeric, coordinates of points where interpolation should occur.
#' @param adims TO BE PRECISED. Default to `lapply(dimnames(a), as.numeric)`.
#' @param method character, TO BE PRECISED. Default to "linear".
#' @param cycling logical, TO BE PRECISED. Default to FALSE.
#' @param bound TO BE PRECISED. Default to 0.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

interpolate = function(
    x, 
    a, 
    adims = lapply(dimnames(a), as.numeric), 
    method = "linear", 
    cycling = FALSE, 
    bound = 0
) {
    
    if (!is.array(a)) 
        stop("a is not an array")
    if (any(unlist(lapply(adims, diff)) < 0)) 
        stop("dimensions of a not ordered")

    if (is.vector(x)) 
        x = matrix(x, nrow = 1)
    dim_a = length(dim(a))
    if (length(method != dim_a))
        method = rep(method, dim_a)[1:dim_a]
    method = pmatch(method, c("constant", "linear"), duplicates.ok = TRUE)
    if (any(is.na(method))) 
        stop("invalid interpolation method")
    method = as.logical(method - 1)
    if (length(cycling != dim_a))
        cycling = rep(cycling, dim_a)[1:dim_a]
    if (length(bound != dim_a))
        bound = rep(bound, dim_a)[1:dim_a]
    x[is.na(x)] = 0 ### 2015-09-21 BECAUSE OF findInterval
    
    convexcoeff = function(x, y) 
    {
        ok = y > 0
        x[ok] = y[ok] - x[ok]
        x
    }

    min_adims = sapply(adims, min)
    max_adims = sapply(adims, max)
    len_adims = sapply(adims, length)

    result = rep(0, nrow(x))

    for (n in 1:nrow(x)) 
    {
        leftidx =  integer(length = dim_a)
        xabstand = rep(0, dim_a)
        aabstand = rep(0, dim_a)
        bincombi = bincombinations(dim_a, method)

        for (k in 1:dim_a) 
        {
            #index = as.integer(0)
            #.C("find_interv_vec", xt = as.double(adims[[k]]), n = length(adims[[k]]), 
            #x = as.double(x[n,k]), nx = as.integer(1), FALSE, FALSE, index, 
            #DUP = FALSE, NAOK = TRUE, PACKAGE = "base")
            #leftidx[k] = index
            leftidx[k] = findInterval(as.double(x[n,k]), as.double(adims[[k]]), FALSE, FALSE)
            if (leftidx[k] == len_adims[k])
            {
                if (cycling[k])
                {
                    bincombi[,k][bincombi[,k] == 1] = 1 - len_adims[k]
                    xabstand[k] = x[n, k] - adims[[k]][len_adims[k]]
                    aabstand[k] = bound[k]
                } else {
                    if (method[k])
                    {
                        leftidx[k] = len_adims[k] - 1
                        xabstand[k] = aabstand[k] = adims[[k]][leftidx[k] + 1] - adims[[k]][leftidx[k]]
                    } else {
                        xabstand[k] = 0
                        aabstand[k] = 1
                    }
               }
            } else if (leftidx[k] == 0)
            {
                if (cycling[k])
                {
                    leftidx[k] = len_adims[k]
                    bincombi[,k][bincombi[,k] == 1] = 1 - len_adims[k]
                    xabstand[k] = x[n, k] + bound[k] - adims[[k]][1]
                    aabstand[k] = bound[k]
                } else {
                    leftidx[k] = 1
                    aabstand[k] = adims[[k]][leftidx[k] + 1] - adims[[k]][leftidx[k]]
                    xabstand[k] = 0
                }
            } else {
                xabstand[k] = x[n, k] - adims[[k]][leftidx[k]]
                aabstand[k] = adims[[k]][leftidx[k] + 1] - adims[[k]][leftidx[k]]
            }
            if (!method[k])
            {
                xabstand[k] = 0
                aabstand[k] = 1
            }
        }

        for (k in 1:nrow(bincombi))
        {
            result[n] = result[n] + element(a, leftidx + bincombi[k, ]) * 
                prod((aabstand - convexcoeff(xabstand, aabstand * 
                as.logical(bincombi[k, ])))/aabstand)
        }
    }
    names(result) = rownames(x)
    result
}

