#' @title load_calendar
#'
#' @description
#' TO BE PRECISED.
#'
#' @param tool TO BE PRECISED.
#' @param input TO BE PRECISED.
#' @param Furniture TO BE PRECISED.
#' @param labour_i TO BE PRECISED.
#' @param path character, subdirectory where to find parameters.
#' @param day numeric, number of days in a week. Default to
#' `getOption("ava")[["day"]]`.
#' @param h_tool numeric, number of hours a day a tool can be used. Default to
#' `getOption("ava")[["h_tool"]]`.
#' 
#' @return list of matrix of calendar parameters.
#'
#' @export
#'
#' @encoding UTF-8

load_calendar = function(
    tool,
    input,
    Furniture,
    labour_i,
    path,
    day = getOption("ava")[["day"]],
    h_tool = getOption("ava")[["h_tool"]]
) {
    r =list()

    r[["labour"]] = list(
        internal = init_calendar("labour", labour_i),
        external = load_parameter("Labour_External.csv", m = TRUE, path))

    r[["tool"]] = list(
        internal = init_calendar(tool, h_tool * day) * Furniture[tool, "quantity"],
        external = load_parameter("Tool_External.csv", m = TRUE, path))

    r[["input"]] = list(
        internal = init_calendar(input),
        external = init_calendar(input))
    
    return(r)
}
