#' @title logging
#'
#' @description
#' TO BE PRECISED.
#'
#' @param the_time list of times.
#' @param r_time POSIXct, time for starting logging. Default to
#' `Sys.time()`.
#' @param output character, file name used to save log information. Default to
#' NULL, in this case an automatic name is constructed,
#'
#' @return TO BE PRECISED.
#'
#' @export
#' 
#' @examples
#' 
#' toto = list(begin = Sys.time())
#' toto[["end"]] =  Sys.time()
#' logging(toto)
#' 
#' output = file.path(tempdir(), "toto.log")
#' logging(toto, output = output)
#'
#' @encoding UTF-8

logging = function(the_time, r_time = Sys.time(), output = NULL) {
    r = character()

    b = names(the_time)[grep("begin", names(the_time))]
    e = gsub("begin", "end", b)
    test = e %in% names(the_time)
    if (!all(test)) {
        msg = paste(
            "Embarrassing,",
            paste(e[!test], collapse= " ; "),
            "not in 'the_time'."
        )
        warning(msg)
    }
    b = b[test]
    e = e[test]
    for (i in seq_along(b)) {
        label = cap(sub("begin_{0,1}", "", b[i]))
        if (label == "") label = "total treatments"
        r = c(r, running(the_time, b[i], e[i], label, instant = FALSE))
    }

    r = c(r, names(warnings()))

    if (!is.null(output)) {
        write(r, output)
        message(sprintf("output saved to %s.", output))
    }
    return(r)
}