#' @title loss_plot
#'
#' @description
#' TO BE PRECISED.
#'
#' @param DPM TO BE PRECISED.
#' @param DC TO BE PRECISED.
#' @param S TO BE PRECISED.
#' @param l_plot TO BE PRECISED.
#' @param harvest TO BE PRECISED, default to NULL.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#'
#' @return TO BE PRECISED, Return numerical vector of length `getOption("ava")[["cal_length"]]`
#'
#' @export
#'
#' @encoding UTF-8

loss_plot = function(
    DPM,
    DC,
    S,
    l_plot,
    harvest = NULL,
    cal_length = getOption("ava")[["cal_length"]]
) {
    calc_loss = function(x) {1 - prod(1 - x)}

    r = matrix(
        NA,
        nrow = length(l_plot),
        ncol = 5,
        dimnames = list(
            "plot" = l_plot,
            "loss" = c("total", "plant_material", "culture", "harvest", "cms")
        )
    )
    for (p in l_plot) {
        r[p, "culture"] = damaging(DC[[p]], S[p, ])
        if (!is.null(harvest)) {
            b = harvest[p, "begin"]
            e = harvest[p, "end"]
            h = S[p, "week"]
            if (e < b) e = e + cal_length
            if (!is.na(h))
            {
                if (h < b) h = h + cal_length
                r[p, "harvest"] = min(max( (e - h + 1)/(e - b + 1), 0), 1)
                if (r[p, "harvest"] == 0) r[p, "harvest"] = 1
            }
        }
        r[p, "plant_material"] = damaging(DPM[[p]], S[p, ])
    }
    r[, "cms"] = apply(
        r[, c("plant_material", "culture"), drop = FALSE],
        1,
        calc_loss
    )
    r[, "total"] = apply(
        cbind(
            r[, c("plant_material"), drop = FALSE],
            r[, c("culture"), drop = FALSE] * r[, c("harvest"), drop = FALSE]
        ),
        1,
        calc_loss
    )
    return(r)
}
