#' @title make_array
#'
#' @description
#' TO BE PRECISED.
#'
#' @param m matrix (or data.frame) with named columns, TO BE PRECISED.
#' @param x vector of character, names of parameters, default to NULL.
#' @param y vector of character, names of output, default to NULL.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

make_array = function(m, x = NULL, y = NULL) {
    
    if (is.null(x) & is.null(y)) stop("Both x and y are NULL")
    if (is.null(x)) x = names(m)[!(names(m) %in% y)]
    if (is.null(y)) y = names(m)[!(names(m) %in% x)]
    if (is.null(x) | is.null(y) | any(x %in% y)) stop("Check x and y")
    test = length(x) > 1
    m = as.matrix(m[, c(x,y)])
    if (test)
    {
        ordering = 
            do.call("order", split(m[, x], ncol(m[, x]) - col(m[, x]) + 1))
    } else {
        ordering = order(m[, x])
    }
    m = m[ordering,]
    
    if (test) d_names = apply(m[, x], 2, unique) else
        d_names = unique(m[, x])
    if (!is.list(d_names))
    {
        if (is.null(dim(d_names)))
        {
            d_names = list(d_names)
        } else
        {
            d_names = split(d_names, col(d_names))
        }
        names(d_names) = x
    }
    d = sapply(d_names, length)
    if (length(y) > 1)
    {
        d = c(d, length(y))
        d_names[["output"]] = y
    }

    array(m[, y], dim = d, dimnames = d_names)
}

