#' @title make_coherent
#'
#' @description
#' TO BE PRECISED.
#'
#' @param M TO BE PRECISED.
#' @param rows TO BE PRECISED, default to NULL.
#' @param cols TO BE PRECISED, default to NULL.
#' @param strict logical, TO BE PRECISED, default to TRUE.
#' @param na TO BE PRECISED, default to 0.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

make_coherent = function(M, rows = NULL, cols = NULL, strict = TRUE, na = 0) {
    if (is.list(M) & !is.data.frame(M)) 
        return(lapply(M, make_coherent, rows, cols, strict, na))
    
    if (is.null(rows) & is.null(cols)) return(M)
    
    is_df = is.data.frame(M)
    M = as.matrix(M)
    if (is.null(rownames(M)) | is.null(colnames(M))) 
        stop("Missing rownames or colnames in M.")
    if (!strict)
    {
        rows = unique(c(rows, rownames(M)))
        cols = unique(c(cols, colnames(M)))
    } else {
        if (is.null(rows)) rows = rownames(M) else
        {
            sel = rownames(M) %in% rows
            M = matrix(M[sel, ], nrow = sum(sel), ncol = ncol(M), 
            dimnames = list(rownames(M)[sel], colnames(M)))
        }
        if (is.null(cols)) cols = colnames(M) else
        {
            sel = colnames(M) %in% cols
            M = matrix(M[, sel], nrow = nrow(M), ncol = sum(sel),
                dimnames = list(rownames(M), colnames(M)[sel]))
        }
    }
    
    r = matrix(na, nrow = length(rows), ncol = length(cols),
        dimnames = list(rows, cols))
    r[rownames(M), colnames(M)] = M
    
    if (is_df) r = as.data.frame(r)
    return(r)
}