#' @title make_damaging
#'
#' @description
#' TO BE PRECISED.
#'
#' @param Damaging : matrix with named columns, including at least one hazard 
#' dimension and one output.
#' @param output : TO BE PRECISED, optional, if an output is to be precised. 
#' By default, all present output are returned, default to NULL.
#' @param method : TO BE PRECISED, optional, a boolean vector of length 
#' ncol(Damaging) or recycled. By default, interpolated, default to NULL.
#' @param level : named list of levels to be used in each dimension if 
#' interpolation is needed, default to NULL.
#' @param ordered_parameter character, hazard dimensions. Default to 
#' `getOption("ava")[["generic"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

make_damaging = function(
    Damaging, 
    output = NULL, 
    method = NULL, 
    level = NULL, 
    ordered_parameter = getOption("ava")[["generic"]]
)
    
{
    n_Damaging = colnames(Damaging)
    parameter =  ordered_parameter[ordered_parameter %in% n_Damaging]
    if ("type" %in% n_Damaging)
    {
        if (is.data.frame(Damaging))
        {
            if (is.character(Damaging[["type"]]))
                Damaging[["type"]] = as.factor(Damaging[["type"]])
            if (is.factor(Damaging[["type"]]))
            {
                type = levels(Damaging[["type"]])
                Damaging[["type"]] = as.integer(Damaging[["type"]])
            }
        }
        if (!is.null(method))
        {
            l = length(parameter)
            method = c(rep(method, l)[seq(l)], "constant")
        }
        parameter = c(parameter, "type")
    }
    if (is.null(output)) 
        output = n_Damaging[!(n_Damaging %in% parameter)] else 
        output = n_Damaging[n_Damaging %in% output]
    if (length(parameter) + length(output) == 0) 
        stop("Trouble with either paremeters or outputs in Damaging.")

    if (is.null(method) | is.null(level))
    {   
        make_array(Damaging, parameter, output)
    } else {
        Damaging = make_array(Damaging, parameter, output)
        Hazard = matrix(expand.grid(lapply(level[parameter], sort)))
        Damaging = cbind(Hazard, damaging(Damaging, Hazard, method, output))
        make_array(Damaging, parameter, output)
    }
}