#' @title normal_functioning
#' 
#' @description
#' TO BE PRECISED.
#'
#' @param P TO BE PRECISED.
#' @param testing logical, TO BE PRECISED, default to FALSE.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

normal_functioning = function(P, testing = FALSE)
{
    r = list()

    ### 1. Calendar of needed labour
    r[["Task"]] = Task = distribute_labour(
        P[["CMS"]][, c("labour", "begin", "end")]) *
            fit_area(
                P[["l_plot"]],
                P[["Farm_Spatial"]][P[["l_plot"]], "area"],
                rownames(P[["CMS"]])
            )
    if (testing) print("1. OK")

    ### 2. Calendar of available tools
    Tool = P[["Calendar"]][["tool"]]
    if (testing) print("2. OK")
    
    ### 3. Calendar of available inputs 
    ### More complicated because depends on purchase and consumption...
    Input = list()
    Input[["internal"]] = need_resource(Task, P[["Task_Input"]])
    Input[["external"]] = init_calendar(rownames(Input[["internal"]]))
    ### Should test buying and see what will stay. TO BE DONE!
    ### Input = calendar_input(Input, P[["Input_Purchase"]])
    if (testing) print("3. OK")
    
    ### 4. Calendar of available labour
    Labour = P[["Calendar"]][["labour"]]
    if (testing) print("4. OK")

    ### 5. Global resolution
    r[["Calendar"]] = solve_task(
        Task,
        Input,
        Tool,
        Labour, 
        P[["Task_Input"]],
        P[["Task_Tool"]],
        p = P[["profile"]]
    )
    if (testing) print("5. OK")
    
    ### 6. Expenses
    selection = names(r[["Calendar"]])[!("task" == names(r[["Calendar"]]))]
    r[["Expense"]] = list()
    r[["Expense"]][["Financial"]] = lapply(
        r[["Calendar"]][selection],
        estimate_expense,
        P[["Cost"]][["Financial"]]
    )
    r[["Expense"]][["Economic"]] = lapply(
        r[["Calendar"]][selection],
        estimate_expense,
        P[["Cost"]][["Economic"]]
    )
#~     r[["Expense"]] = estimate_expense(r[["Calendar"]][["plot"]][c("Input", "Tool", "Labour")], 
#~         P[["Cost"]][["Financial"]])
    if (testing) print("6. OK")

    ### 7. Product
    r[["Product"]] = estimate_product(
        r[["Calendar"]][["task"]],
        P[["CMS"]][, c("labour", "loss")], 
        P[["Farm_Spatial"]][P[["l_plot"]], c("yield", "area", "price")]
    )
    if (testing) print("7. OK")
        
    ### 8. Incomes
    r[["Income"]] = estimate_income(
        r[["Expense"]][["Financial"]][["plot"]],
        r[["Product"]]
    )
    if (testing) print("8. OK")
    
    ### 9. Calendar of present Input
    r[["Input"]] = calendar_input(
        r[["Calendar"]][["plot"]][["input"]][["internal"]],
        P[["Input_Purchase"]],
        P[["path"]], P[["profile"]]
    )
    if (testing) print("9. OK")
    
    ### 10. Putting benchmark in Damage
    r[["Damage"]] = list()
    r[["Damage"]][["Financial"]] = estimate_dam_financial(
        NP = r[["Product"]],
        NE = r[["Expense"]][["Financial"]],
        benchmark = TRUE)
    r[["Damage"]][["Economic"]] = estimate_dam_economic(
        r[["Product"]],
        r[["Expense"]][["Economic"]], 
        benchmark = TRUE
    )
    
    if (P[["profile"]] == "external") {
        save_external(
            r[["Calendar"]][["plot"]],
            P[["path"]]
        )
    }
   
    return(r)
}
