#' @title running
#' 
#' @description
#' TO BE PRECISED.
#'
#' @param the_time list of times.
#' @param b character, TO BE PRECISED, default to "begin".
#' @param e character, TO BE PRECISED, default to "end".
#' @param label TO BE PRECISED, default to NULL.
#' @param instant logical, TO BE PRECISED, default to TRUE.
#'
#' @return TO BE PRECISED
#'
#' @export
#' 
#' @examples
#' 
#' toto = list(begin = Sys.time())
#' toto[["end"]] =  Sys.time()
#' running(toto)
#'
#' @encoding UTF-8

running = function(
    the_time,
    b = "begin",
    e = "end",
    label = NULL,
    instant = TRUE
) {
    dif = the_time[[e]] - the_time[[b]]
    if (is.null(label)) label = paste("from ", b, " to ", e, ":", sep = "") else
        label = paste("for ", label,":", sep = "")
    dif = switch(attr(dif, "units"),
        secs = paste(round(dif, 1), "secs"),
        mins = paste(trunc(dif), "mins", round((dif - trunc(dif)) * 60, 1), 
            "secs"),
        hours = paste(trunc(dif), "hours", trunc(temp <- (dif - trunc(dif)) * 
            0), "mins", round((temp - trunc(temp)) * 60, 1), "secs"),
        paste(dif, attr(dif, "units")))
    msg = paste("Running time", label, dif, "\n")
    if (instant) cat(msg) else return(sub("\n", "", msg))
}