#' @title shift_labour
#' 
#' @description
#' Shift labour because of hazard, respecting constraint given by end of task. TO BE PRECISED.
#'
#' @param end TO BE PRECISED.
#' @param Cal TO BE PRECISED.
#' @param Pert TO BE PRECISED, default to NULL.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#'
#' @return numeric vector of length `getOption("ava")[["cal_length"]]`, TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

shift_labour = function(
    end,
    Cal,
    Pert = NULL,
    cal_length = getOption("ava")[["cal_length"]]
) {
    
    if (is.vector(Cal)) Cal = t(Cal)
    
    r = Cal
    
    if (is.null(Pert)) return(r)
    if (is.vector(Pert)) 
        Pert = matrix(Pert[1:2], byrow = TRUE, nrow = nrow(Cal), ncol = 2)
    if (!all(dim(Pert) == c(nrow(Cal), 2))) return("Bad dimension for Off")
    Off = select_calendar(Pert)    
    labour = rowSums(r * Off)
    r[Off] = 0
    
    Pert[, 2] = fit_date(Pert[, 2] + 1)
    extra = cbind(Pert[, 2], end)
    extra[t(Off)[end + (seq(nrow(Cal)) - 1) * cal_length],] = NA
    extra = select_calendar(extra)
    labour = labour / rowSums(extra)
    labour[is.infinite(labour)] = 0
    labour[is.nan(labour)] = 0
    r = r + extra * labour

    return(r)
}