#' @title solidarity
#' 
#' @description
#' TO BE PRECISED.
#'
#' @param Flood TO BE PRECISED.
#' @param Normal TO BE PRECISED.
#' @param Price TO BE PRECISED.
#' @param Expense TO BE PRECISED.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

solidarity = function(Flood, Normal, Price, Expense) {
    repartition = function(Flood, Normal)
    {
        dif = function(A, B)
        {
            common = sort(unique(rownames(A), rownames(B)))
            A = rowSums(make_coherent(A, rows = common))
            B = rowSums(make_coherent(B, rows = common))
            r = list(
                external = pmin(A, B),
                solidarity = pmax(A - B, 0))
            return(r)
        }
        
        r = list()
        for (a in names(Flood))
        {
            if (!(a %in% names(Normal))) 
            {
                r[[a]] = list(
                    tool = dif (n <- Flood[[a]][["tool"]][["external"]], init_calendar(n)),
                    labour = dif (n <-Flood[[a]][["labour"]][["external"]], init_calendar(n)))
            } else {
                r[[a]] = list(
                    tool = dif (Flood[[a]][["tool"]][["external"]], Normal[[a]][["tool"]][["external"]]),
                    labour = dif (Flood[[a]][["labour"]][["external"]], Normal[[a]][["labour"]][["external"]]))
            }
        }
        return(r)
    }
    
    correction = function(Quantity , Price)
    {
        
        r = array(NA, dim = c(2, 3), dimnames = list(
            resource = c("tool", "labour"),
            entry = c("soil", "building", "plot")))
            
        for (entry in dimnames(r)[["entry"]])
        {
            for (resource in dimnames(r)[["resource"]])
            {
                quantity = Quantity[[entry]][[resource]][["solidarity"]]
                old = quantity * Price[[resource]][names(quantity), "external"]
                new = quantity * Price[[resource]][names(quantity), "solidarity"]
                r[resource, entry] = sum(new - old, na.rm = TRUE)
            }
        }
        return(r)
    }

    adjust = function(Expense, Correction)
    {
        resource = rownames(Correction)
        r = Expense
        for (entry in colnames(Correction)) 
            r[[entry]][resource] = 
                r[[entry]][resource] + Correction [resource, entry]
        return(r)
    }
    
    r = list()
    r[["Repartition"]] = repartition(Flood, Normal[names(Normal) %in% names(Flood)])
    r[["Correction"]] = correction(r[["Repartition"]], Price)
    r[["Expense"]] = adjust(Expense, r[["Correction"]])
    return(r)
}