#' @title solve_task
#' 
#' @description
#' TO BE PRECISED.
#'
#' @param Task Matrix or (list of matrices) of tasks to be done, TO BE PRECISED.
#' @param AI Calendar of available units of inputs, TO BE PRECISED.
#' @param AT Calendar of available units of tools, TO BE PRECISED.
#' @param AL Calendar of available units of labour, TO BE PRECISED.
#' @param TI Matrix of links giving what inputs are needed for each task, TO BE PRECISED.
#' @param TT Matrix of links giving what tools are needed for each task, TO BE PRECISED.
#' @param other TO BE PRECISED, default to NULL.
#' @param p character, profile, TO BE PRECISED, default to "internal".
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8

solve_task = function(Task, AI, AT, AL, TI, TT, other = NULL, p = "internal") {
    r = list()
    r[["plot"]] = list()
    
    TL = matrix(1, nrow = nrow(Task), ncol = 1, 
        dimnames = list(rownames(Task),"labour"))
    
    Task = adapt_task(Task, AI, TI, "internal")
    Task = adapt_task(Task, AT, TT, p)
    Task = adapt_task(Task, AL, TL, p)
    
    r[["task"]] = Task
    r[["plot"]][["task"]] = rownames(Task)
    r[["plot"]][["input"]] = Input = distribute_resource(Task, AI, TI, "internal")
    r[["plot"]][["tool"]] = Tool = distribute_resource(Task, AT, TT, p)
    r[["plot"]][["labour"]] = Labour = distribute_resource(Task, AL, TL, p) 
   
    
    if (is.null(other)) return(r)
        
    for (e in names(other))
    {
        r[[e]] = list()
        r[[e]][["task"]] = Task[other[[e]], ]
        if (length(other[[e]]) == 1)
        {
            r[[e]][["task"]] = t(r[[e]][["task"]])
            rownames(r[[e]][["task"]]) = other[[e]]
        }
        r[[e]][["input"]] = sub_distribute_resource(Input, r[[e]][["task"]], TI)
        r[[e]][["tool"]] =  sub_distribute_resource(Tool, r[[e]][["task"]], TT)
        r[[e]][["labour"]] =  sub_distribute_resource(Labour, r[[e]][["task"]], TL)
        r[[e]][["task"]] = other[[e]]
        r[["plot"]] = subtract(r[["plot"]], r[[e]])
    }

    return(r)
}