#' @title usability
#' 
#' @description
#' TO BE PRECISED.
#'
#' @param A Matrix with two or three columns giving beginning and duration of 
#' troubles, and possible duration of post-perturbation, TO BE PRECISED.
#' @param cal_length numeric, number of weeks in calendar. Default to
#' `getOption("ava")[["cal_length"]]`.
#'
#' @return TO BE PRECISED
#'
#' @export
#'
#' @encoding UTF-8


usability = function(
    A,
    cal_length = getOption("ava")[["cal_length"]]
)
    # - Value: Calendar of boolean vector of nrow = nrow(A)
{
    fun = function(x)
    {
        r = rep(TRUE, cal_length)
        b = x[1]
        e = b + x[2] + x[3] - 1
        if (is.na(b) | e < b) return(r)
        if (e > cal_length) {
            r[1:(e - cal_length)] = r[b:cal_length] = FALSE
        } else {
            r[b:e] = FALSE
        }
        r
    }
    
    if (is.data.frame(A)) A = as.matrix(A)
    if (!is.matrix(A)) stop("A should be a matrix.")
    if (ncol(A) == 2) A = cbind(A, 0)
    r = t(apply(A, 1, fun))
    dimnames(r) = list("asset" = rownames(A), "week" = seq(cal_length))
    return(r)
}