#' ava
#' 
#' QUICK DESCRIPTION OF ava
#' 
#' @docType package
#' @author Frédéric Grelot <frederic.grelot@inrae.fr>
#' @name ava
NULL

.onLoad = function(libname, pkgname){
    options(
        ava = list(
            cal_length = 52,
            catnat = list("min" = 1140, "rate" = .1),
            checking = TRUE,
            correct = TRUE,
            day = 7,
            day_offset = 3,
            expense_cat = c("input", "tool", "labour"),
            fngca = list(
                "land" = .3,
                "global" = .13,
                "Arboriculture" = list(threshold = .3, "rate" = .3),
                "Vineyard" = list(threshold = .3, "rate" = .3),
                "Wheat" = list(threshold = .3, "rate" = .3),
                "Salad" = list(threshold = .3, "rate" = .3),
                "Melon" = list(threshold = .3, "rate" = .3)
            ),
            generic = "Generic",
            hazard_dim = c("height", "duration", "speed", "week"),
            h_tool = 12,
            path_input = "Input",
            month = c(1 , 5 , 9 , 14 , 18 , 23 , 27 , 31 , 36 , 40 , 44 , 48 , 52),
            path_output = "Output",
            param_list = list(
                path = "",
                output = "",
                profile = "internal",
                save = T,
                graph = F,
                Farm_Labour = "Farm_Labour.csv",
                Farm_Spatial = "Farm_Spatial.csv",
                Damaging_Building = "Damaging_Building.csv",
                Damaging_Furniture = "Damaging_Furniture.csv",
                Discount_Tool = "Discount_Tool.csv",
                Furniture = "Furniture.csv",
                Hazard = "Hazard.csv",
                Labour = "Labour.csv",
                Input = "Input.csv",
                Input_Purchase = "Input_Purchase.csv",
                Task_Flood = "Task_Flood.csv",
                Tool = "Tool.csv"
            ),
            process = c("internal", "external"),
            threshold = .95
        )
    )
    invisible()
}

# .onUnload() = function(libpath){
#   library.dynam.unload("floodam.cba", libpath)
#   options(floodam.cba = NULL)
# }