% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_parameter.R
\encoding{UTF-8}
\name{load_parameter}
\alias{load_parameter}
\title{load_parameter}
\usage{
load_parameter(
  parameter,
  path,
  m = FALSE,
  generic = getOption("ava")[["generic"]],
  path_input = getOption("ava")[["path_input"]],
  row.names = 1,
  checking = getOption("ava")[["checking"]],
  ...
)
}
\arguments{
\item{parameter}{character, name of the file of parameter to be loaded.}

\item{path}{character, subdirectory where to find parameters.}

\item{m}{logical, should the result be returned as a matrix.}

\item{generic}{character, default name for the file of parameters to be
loaded. Default to \code{getOption("ava")[["generic"]]}.}

\item{path_input}{character, directory where to find \code{path}. Default to
\code{getOption("ava")[["path_input"]]}.}

\item{row.names}{integer, columns where to find row.names. Default to 1.}

\item{checking}{logical, should the parameters be checked. Default to
\code{getOption("ava")[["checking"]]}.}

\item{...}{other parameters that will be passed to \code{utils::read.csv2()}.}
}
\value{
Either a data.frame or a matrix of parameters.
}
\description{
Reading farm parameter from csv (semi-colon) file to the correct format.
}
